
/*

   remember v2.10

   10/29/1996

   "pa.c"     parameter analysis

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#include "remember.h"
#include "pa.h"
#include "spt.h"

void rememberInit(int argc, char **argv){

  int i, j, tmp, tmpJap, tmpEng;
  char *tmps, filename[TOKEN_LENGTH];
  pairTable *tmpPT;

  j = 0;
  
  dispState = STATE_NULL_PTS;
  reverseFlag = False;
  paceQ = DEFAULT_PACE;
  paceA = DEFAULT_PACE;
  current = DEFAULT_CURRENT;
  chaseMode = DEFAULT_CHASE_MODE;
  shuffleMode = DEFAULT_SHUFFLE_MODE;

  srand(time(NULL));

  if (argc < 2)
    dispUsage(argv[0]);

  for(i = 1; i < argc; i++)
    if (strcmp("-qp", argv[i]) == 0){
      if (i >= argc - 1)
	break;
      sscanf(argv[i + 1], "%i", &tmp);
      if (tmp < 0)
	paceQ = 0;
      else if (tmp > MAX_PACE)
	paceQ = MAX_PACE;
      else
	paceQ = tmp;
      i += 1;
    }
    else if (strcmp("-ap", argv[i]) == 0){
      if (i >= argc - 1)
	break;
      sscanf(argv[i + 1], "%i", &tmp);
      if (tmp < 1)
	paceA = 1;
      else if (tmp > MAX_PACE)
	paceA = MAX_PACE;
      else
	paceA = tmp;
      i += 1;
    }      
    else if (strcmp("-cjap", argv[i]) == 0)
      current = JAP;
    else if (strcmp("-ceng", argv[i]) == 0)
      current = ENG;
    else if (strcmp("-chase", argv[i]) == 0)
      chaseMode = CHASE;
    else if (strcmp("-nsh", argv[i]) == 0)
      shuffleMode = DONT_SHUFFLE;
    else{
      strcpy(filename, argv[i]);
      if (strstr(filename, ".dic") == NULL)
	strcat(filename, ".dic");

      if ((j < PAIR_TABLE_MAX_NUM) && 
	  ((tmpPT = setPairTable(filename, &tmpEng, &tmpJap)) != NULL)){
	pTS[j].pT = tmpPT;
	pTS[j].eng = tmpEng;
	pTS[j].jap = tmpJap;
	j += 1;
      }
    }
  if (j == 0)
    dispUsage(argv[0]);

  numPTS = j;
}

void dispUsage(char *comm){

  printf("Usage: %s [-qp <question_pace>][-ap <answer_pace>]\n                [-cjap][-ceng][-chase][-nsh][-g <geometry>]\n                 <dictionary_file1>[dictionary_file2] ...[dictionary_file5]\n", comm);
  exit(1);

}

