
/*

   remember v2.10

   10/29/1996

   "remember.h"       "remember" common header

*/

#ifndef REMEMBER_H
#define REMEMBER_H

#define True 1
#define False 0

#define PAIR_TABLE_MAX_NUM 5

#define MAX_PACE 10
#define DEFAULT_PACE 5
#define EMP_PACE 1

#define BASIC_WINDOW_WIDTH 360
#define BASIC_WINDOW_HEIGHT 80
#define BASIC_WORD_X_POS 24
#define BASIC_ENG_WORD_Y_POS 35
#define BASIC_JAP_WORD_Y_POS 70

#define ENG_FONT_NAME "-adobe-helvetica-bold-r-*-*-24-*-*-*-*-*-*-*"

#define ENG 0
#define JAP 1
#define CHASE 0
#define DONT_CHASE 1
#define SHUFFLE 0
#define DONT_SHUFFLE 1

#define DEFAULT_CURRENT ENG
#define DEFAULT_CHASE_MODE DONT_CHASE
#define DEFAULT_SHUFFLE_MODE SHUFFLE

#define STATE_NULL_PTS 0
#define STATE_DISP_QUE 1
#define STATE_DISP_ANS 2
#define STATE_ERASE 3

typedef struct {
  char *english;
  char *japanese;
} pairTable;

typedef struct {
  pairTable *pT;
  int eng;
  int jap;
} pairTableSet;

void loop();
void dirControler();

extern int current, oldCur;
extern int chaseMode, shuffleMode, dispState, reverseFlag;
extern int paceQ, paceA;
extern int numPTS;
extern int pTI, pTSI;
extern pairTableSet pTS[PAIR_TABLE_MAX_NUM];

#endif
