
/*

   remember v2.10

   10/29/1996

   "spt.c"         functions concerning setting up PT

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "remember.h"
#include "spt.h"

void arrangePTS(){

  int i;

  if (shuffleMode == SHUFFLE)
    for(i = 0; i < numPTS; i++)
      shufflePTable(pTS[i].pT, pTS[i].jap);

}

void openError(){

  fprintf(stderr,"Can't open file.\n");
    exit(1);

}

int chkEmpty(char *buffer){

  int length, i;

  length = strlen(buffer);

  for(i = 0; i < length - 1; i++)
    if ((i != 0) && (buffer[i] != 0x20))
      return 1;

  return 0;

}

int getNumOfEngWord(char *filename){

  FILE *fp;
  char tmp[LINE_MAX_LENGTH];
  int i = 0;

  if ((fp = fopen(filename, "r")) == NULL)
    openError();

  while(fgets(tmp, LINE_MAX_LENGTH, fp) != NULL)
    i++;

  fclose(fp);

  return i;
}

int getNumOfJapWord(char *filename){

  FILE *fp;
  int i = 0;
  char c;

  if ((fp = fopen(filename, "r")) == NULL)
    openError();  

  while((c = fgetc(fp)) != EOF)
    if (c ==',')
      i++;

  fclose(fp);

  return i;
}

pairTable *setPairTable(char *filename, 
			   int *eng, int *jap){

  pairTable *pT;
  FILE *fp;
  char buff[LINE_MAX_LENGTH], *tokE, *tokJ;
  int i, co, en, ja, bufLen;

  co = 0;

  en = *eng = getNumOfEngWord(filename);
  ja = *jap = getNumOfJapWord(filename);

  if ((fp = fopen(filename, "r")) == NULL)
    openError();

  pT = (pairTable *)malloc(sizeof(pairTable) * ja);

  for(i = 0; i < en; i++){
    if (fgets(buff, LINE_MAX_LENGTH, fp) == NULL)
      return (NULL);
    bufLen = strlen(buff);
    buff[bufLen - 1] = '\0';
    if (chkEmpty(buff) != 0){
      if ((tokE = strtok(buff, ",")) == NULL)
	return (NULL);
      else
	while((tokJ = strtok(NULL, ",")) != NULL){
	  pT[co].english = (char *)malloc(sizeof(char) * strlen(tokE) + 1);
	  pT[co].japanese = (char *)malloc(sizeof(char) * strlen(tokJ) + 1);
	  strcpy(pT[co].english, tokE);
	  strcpy(pT[co].japanese, tokJ);
	  co += 1;
	}
    }
  }
      
  fclose(fp);

  return pT;
}

void shufflePTable(pairTable *pT, int jap){

  int i, s;
  pairTable tmp;

  for(i = 0; i < jap; i++){
    s = rand() % jap;
    swapPTable(&(pT[i]), &(pT[s]));
  }
}

void swapPTable(pairTable *pT1, pairTable *pT2){

  char *tmpStr;

  if (pT1 != pT2){
    
    tmpStr = pT1->english;
    pT1->english = pT2->english;
    pT2->english = tmpStr;

    tmpStr = pT1->japanese;
    pT1->japanese = pT2->japanese;
    pT2->japanese = tmpStr;
  }
}
